S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

# INSTALLATION

## Update composer
Before proceding to install, run: 

```sh
php composer.phar update
```

## Update .htaccess file
Change route at .htaccess.

```sh
# Installation directory
RewriteBase /%your_installation_path%
```

For example, if you are running sgae3 on `http(s)://myserver.com/sgae3`,
your RewriteBase must be:
```apacheconf 
RewriteBase /sgae3
```

## File permissions
If you want the configuration file to be automatically written by the installer process, change your installation folder permissions.

For example, if you server is Apache and is running as `www-data`, and your installation folder is `/var/www/sgae3`, run:

```sh
chown www-data /var/www/sgae3
```
Otherwise, you will be asked to manually copy and paste the configuration file contents.

## Visit installer url
Head to `http(s)://%my_sgae3_root%/installer/install.phtml` and follow the steps in there.


# CRON configuration
Once the application is installed, visit `http(s)://%my_sgae3_root%/admin` and register the desired Slurm Partitions. In order to load data from those partitions, head to the "Cron" tab and click "Run Cron". Check your log for further details.

To periodically run the cron task, add a line to you `crontab`. In this example the cron is run every day at 00:00:

```sh
00 00 * * *   www-data %sgae_installation_folder%/cron/cron.sh
```
