<?php
/*
S-GAE (Simple Graphical Accounting Engine) is a web application developed at /rdlab to 
graphically display the accounting information generated by our HPC queue manager.

Copyright (C) +2020  rdlab@cs.upc.edu - https://rdlab.cs.upc.edu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

namespace sgae3\Helper;

use MySQLI;
use Exception;

class Database
{

    private $myqli;

    private $result;

    function __construct()
    {
        $this->mysqli = new MySQLI($GLOBALS['db_host'], $GLOBALS['db_user'], $GLOBALS['db_password'], $GLOBALS['db_name'], $GLOBALS['db_port']);
        if (mysqli_connect_errno()) {
            throw new Exception("Unable to connect to database: " . mysqli_connect_error());
        }
    }

    public function query($query)
    {
        if (! $this->result = $this->mysqli->query($query)) {
            trigger_error("Database error: " . $this->mysqli->error, E_USER_WARNING);
            return false;
        }
        return true;
    }

    public function fetch_one()
    {
        if (! $this->result) {
            trigger_error("Trying to fetch from empty resultset.", E_USER_WARNING);
            return array();
        }
        return mysqli_fetch_assoc($this->result);
    }

    public function fetch_all()
    {
        if (! $this->result) {
            trigger_error("Trying to fetch from empty resultset.", E_USER_WARNING);
            return array();
        }
        $rows = array();
        while ($row = mysqli_fetch_assoc($this->result)) {
            $rows[] = $row;
        }
        return $rows;
    }

    public function num_results()
    {
        return $this->result->num_rows;
    }

    public function free()
    {
        $this->result->free();
    }

    public function error()
    {
        return $this->mysqli->error;
    }

    public function insert_id()
    {
        return $this->mysqli->insert_id;
    }

    public function real_escape_string($string)
    {
        return $this->mysqli->real_escape_string($string);
    }
}

?>